package com.googlecode.jpattern.jobexecutor.console;

import com.googlecode.jpattern.jobexecutor.IBooleanWrapper;
import com.googlecode.jpattern.jobexecutor.ICommandExecutorHandler;
import com.googlecode.jpattern.jobexecutor.IWrappedResult;

/**
 * 
 * @author Francesco Cina'
 *
 * 05/apr/2010
 */
public class UnknownCommandExecutorHandler implements ICommandExecutorHandler {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	public String getCommandDescription() {
		return "Unknown command received from client";
	}

	public String getCommandName() {
		return ICommandExecutorHandler.COMMAND_UNKNOWN;
	}

	public ICommandExecutorHandler exec(String commandLine, IWrappedResult wrappedResult, IBooleanWrapper stopCommandExecution) {
		stopCommandExecution.setValue(true);
		wrappedResult.add( getCommandDescription() + ": " + commandLine);
		
		return new NullCommandExecutorHandler();
	}

}
